## 数据类型

- ToString()
  返回对象的原始字符串表示。对于 Object 对象，ECMA-262 没有定义这个值，所以不同的 ECMAScript 实现具有不同的值。
- ValueOf()
  返回最适合该对象的原始值。对于许多对象，该方法返回的值都与 ToString() 的返回值相同。

#### 引用类型/基本类型

stack 为自动分配的内存空间，它由系统自动释放；而 heap 则是动态分配的内存，大小不定也不会自动释放。

- 基本类型：存放在栈内存中的简单数据段，数据大小确定，内存空间大小可以分配。
  5 种基本数据类型有 Undefined、Null、Boolean、Number 和 String，它们是直接按值存放的，所以可以直接访问。
- 引用类型：存放在堆内存中的对象，变量实际保存的是一个指针，这个指针指向另一个位置。每个空间大小不一样，要根据情况开进行特定的分配。
  当我们需要访问引用类型（如对象，数组，函数等）的值时，首先从栈中获得该对象的地址指针，然后再从堆内存中取得所需的数据。
