#### 区别

意外的键

- Map 默认情况不包含任何键。只包含显式插入的键。
- 一个 Object 有一个原型, 原型链上的键名有可能和你自己在对象上的设置的键名产生冲突。tips: 虽然 ES5 开始可以用 Object.create(null) 来创建一个没有原型的对象，但是这种用法不太常见。
  键的类型
- 一个 Map 的键可以是任意值，包括函数、对象或任意基本类型。
- 一个 Object 的键必须是一个 String 或是 Symbol。
  键的顺序
- Map 中的 key 是有序的。因此，当迭代的时候，一个 Map 对象以插入的顺序返回键值。
- 一个 Object 的键是无序的。注意 ：自 ECMAScript 2015 规范以来，对象确实保留了字符串和 Symbol 键的创建顺序； 因此，在只有字符串键的对象上进行迭代将按插入顺序产生键。
  性能
- 在频繁增删键值对的场景下表现更好。
- 在频繁添加和删除键值对的场景下未作出优化。
  迭代
- Map 是 iterable 的，所以可以直接被迭代。
- 迭代一个 Object 需要以某种方式获取它的键然后才能迭代
  Size
- Map 的键值对个数可以轻易地通过 size 属性获取
- Object 的键值对个数只能手动计算

#### map&Object 应用场景

尽管，Map 相对于 Object 有很多优点，依然存在某些使用 Object 会更好的场景，毕竟 Object 是 JavaScript 中最基础的概念。

如果你知道所有的 key，它们都为字符串或整数（或是 Symbol 类型），你需要一个简单的结构去存储这些数据，Object 是一个非常好的选择。

构建一个 Object 并通过知道的特定 key 获取元素的性能要优于 Map（字面量 vs 构造函数，直接获取 vs get()方法）。

如果需要在对象中保持自己独有的逻辑和属性，只能使用 Object。

JSON 直接支持 Object，但尚未支持 Map。因此，在某些我们必须使用 JSON 的情况下，应将 Object 视为首选。

Map 是一个纯哈希结构，而 Object 不是（它拥有自己的内部逻辑）。使用 delete 对 Object 的属性进行删除操作存在很多性能问题。所以，针对于存在大量增删操作的场景，使用 Map 更合适。

不同于 Object，Map 会保留所有元素的顺序。Map 结构是在基于可迭代的基础上构建的，所以如果考虑到元素迭代或顺序，使用 Map 更好，它能够确保在所有浏览器中的迭代性能。

Map 在存储大量数据的场景下表现更好，尤其是在 key 为未知状态，并且所有 key 和所有 value 分别为相同类型的情况下。
