#### 闭包
>
 当函数可以记住并访问所在的词法作用域，即使函数是在当前词法作用域之外执行，这就产生了闭包
>
#### 闭包特性
>
 每个函数都是闭包，每个函数天生都能够记忆自己定义时所处的作用域环境 
>
#### 闭包的内存泄漏
>
 全局作用域----只有当页面关闭的时候全局作用域才会销毁
 私有的作用域----只有函数执行才会产生
 >
   一般情况下，函数执行会形成一个新的私有的作用域，当私有作用域中的代码执行完成后，我们当前作用域都会主动的进行释放和销毁。但当遇到函数执行返回了一个引用数据类型的值，并且在函数的外面被一个其他的东西给接收了，这种情况下一般形成的私有作用域都不会销毁
 >
 ```js
    function outer(){
    var num=0;//内部变量
    return function add(){//通过return返回add函数，就可以在outer函数外访问了
    num++;//内部函数有引用，作为add函数的一部分了
    console.log(num);
    };
    }
    var func1=outer();
    func1();//实际上是调用add函数， 输出1
    func1();//输出2 因为outer函数内部的私有作用域会一直被占用
    var func2=outer();
    func2();// 输出1  每次重新引用函数的时候，闭包是全新的。
    func2();// 输出2   
 ```
>
#### 闭包的作用
>
    1.可以读取函数内部的变量。
    2.可以使变量的值长期保存在内存中，生命周期比较长。因此不能滥用闭包，否则会造成网页的性能问题
    3.可以用来实现JS模块。
    JS模块:具有特定功能的js文件,将所有的数据和功能都封装在一个函数内部(私有的),只向外暴露一个包信n个方法的对象或函数,模块的使用者,只需要通过模块暴露的对象调用方法来实现对应的功能。
>
```js
       for (var i = 0; i < btns.length; i++) {
        (function (j) {
            btns[j].onclick = function () {
            console.log('第' + (j + 1) + '个')
            }
        })(i)
        }
    ```