## 从浏览器输入 URL 到页面展示过程发生了什么？

#### Chrome 的多进程架构：
- 浏览器进程，它负责用户界面（地址栏、菜单等等）、子进程的管理（例如，进程间通信和数据传递）、存储等等渲染进程，它负责将接收到的 HTML 文档和 JavaScript 等转化为用户界面
- 网络进程，它负责网络资源的请求，例如 HTTP请求、WebSocket 模块GPU（图形处理器）进程，它负责对 UI 界面的展示
- 插件进程，它负责对插件的管理

#### 解析地址
在网络进程接收到 URL 后，并不是马上对指定 URL 进行请求。
首先，我们需要进行 DNS 解析域名得到对应的 IP，
然后通过 ARP 解析 IP 得到对应的 MAC（Media Access Control Address）地址。

##### 1. DNS 解析
而 DNS 解析域名的过程分为以下几个步骤：
- 询问浏览器 DNS 缓存
- 询问本地操作系统 DNS 缓存（即查找本地 host 文件
- 询问 ISP（Internet Service Provider）互联网服务提供商（例如电信、移动）的 DNS 服务器询问根服务器，
这个过程可以进行递归和迭代两种查找的方式，两者都是先询问顶级域名服务器查找

##### 2. 通信过程
首先，建立 TCP 连接，即三次握手过程：
- 客户端发送标有 SYN 的数据包，表示我将要发送请求。
- 服务端发送标有 SYN/ACK 的数据包，表示我已经收到通知，告知客户端发送请求。
- 客户端发送标有 ACK 的数据包，表示我要开始发送请求，准备被接受。

如果 TCP 握手的次数只有两次，那么接收方只能选择接受请求或者拒绝接受请求，但它并不清楚这次的请求是正常的请求，还是由于网络环境问题而导致的过期请求，如果是过期请求的话就会造成错误的连接。


断开 TCP 连接，即四次握手过程：

- 客户端发送请求，申请断开连接，进入等待阶段，此时不会发送数据，但是会继续接收数据。
- 服务端接收请求后，告知客户端已明白，此时服务端进入等待状态，不会再接收数据，但是会继续发送数据。
- 客户端收到后，进入下一阶段等待。服务端发送完剩余的数据后，告知客户端可以断开连接，此时服务端不会发送和接收数据。
- 客户端收到后，告知服务端我开始断开连接。服务端收到后，开始断开连接。

参照三次握手机制，挥手最少需要三次，如果只有三次，客户端发送完数据请求断开连接，而服务端不一定也同样发送完数据，若同时回ACK和FIN给客户端，断开连接，可能造成数据的损坏；若先发送ACK，再等B的数据发送完了再发送FIN和ACK，就可以保证传输数据的完整性。

tcp是全双工模式，接收到FIN意味着将没有数据再发来，但是还是可以继续发送数据。
tcp四次挥手，由于TCP连接是全双工的，因此每个方向都必须单独进行关闭。


#### js 解析
针对每句代码进行分行处理，即 Token 化
根据 Token，生成 AST（Abstract Sytanx Tree) 抽象语法树和创建上下文
解释器解析和执行 AST，生成字节码。
编译器针对需要反复执行的代码，生成对应的机器码，提高运行效率

