## 计算机网络体系结构

- 分层结构 参考模型
- 模块化 利于系统更新维护
- 利于标准化
- 服务访问点 【服务原语】

## OSI 参考模型

- 应用层
- 表示层
- 会话层
- 传输层
- 网络层
- 数据链路层
  - 比特传输
- 物理层
  - 传输介质

#### 通信过程

- 主机 七层
- 路由器
  - 网络层
  - 数据链路层
  - 物理层

#### 物理层

- 接口特性
  - 机械特性
  - 电器特性
  - 功能特性
  - 规程特性
- 比特编码
- 数据率
- 比特同步
  - 时钟同步
- 传输模式
  - 单工模式 电视
  - 半双工 交替 对讲机
  - 双工

#### 数据链路层

- 节点->节点 数据传输
- 组帧 头尾
- 物理寻址 帧头里增加物理地址 广播通信
- 流量控制 匹配两端网络速率
- 差错控制
  检测或重传损失或丢失帧，避免重复帧
- 接入/访问 控制

#### 网络层

原主机->目的主机 数据分组交付

- 逻辑寻址 IP 跨越多个网络
- 路由功能 路径选择
- 分组转发

#### 传输层

端到端 进程间完整报文传输

- 分段重组
- SAP 寻址 正确的进程 eg：端口号
- 端到端链接控制 连接建立与拆除
- 端到端的流量控制
- 差错控制 TCP 实现/UDP 不实现

#### 会话层 (不单独存在)
- 会话控制 建立/维护/拆除
- 会话同步 同步点

#### 表示层 (一般应用层里实现)
- 端到端 语法/语义 转化
- xx-> 独立编码 ->yy
- 加密解密，压缩/解压缩
#### 应用层
应用协议 HTTP/FTP/SMTP
提供用户使用网络的接口/网络代理eg:浏览器

### TCP/IP
[TCP-IP](./TCP-IP.md)
五层模型
主机: 应用层/传输层/网络层/链路层/物理层
交换机: 链路层/物理层
路由器: 网络层/链路层/物理层