## 计算机网络 -> 传输层

- 多路复用/分用
- 可靠数据传输机制
- 流量控制机制
- 拥塞控制机制

### 传输层服务/协议

为运行在不同 host 上的应用进程提供逻辑通信机制
网络层主机间逻辑通信机制 IP
应用层 -> segment(报文段) 网络层 组装成消息 -> 应用层

#### TCP/UDP

TCP 可靠/按序交付
【进程/线程】

- 多路复用 从多个 socket 接收数据，加上头部信息，生成 segment 交给网络层
- 多路分用 多个发送端同时发送信息传输层依据头部信息交给正确的 socket /进程

#### UDP

- User Datagram Protocol
- 优势
  - 无连接->延迟减少/实现简单
  - 头部开销少
  - 没有拥塞控制->刚好的调整发送时间和速率
  - 应用层增加可靠机制/错误恢复机制
- 应用: 流媒体/DNS
- 报文格式
  - 头部: 源端口/目的端口
  - UDP 校验和
    检验 UDP 段传输过程有没有发生错误
- 基于 IP 协议 特点
  - 多路复用/分用
  - 简单的错误校验
  - 丢失 IP: 尽力而为的服务
  - 非按序到达
  - 无连接
  - 无需握手
  - 每个链接独立于其他

### 可靠数据传输
不可靠信道->可靠的传输  
rdt: 可靠信息传输协议 接口 
【有限状态自动机】
- rdt1.0 底层完全可靠、发送/接受方FSM独立
- rdt2.0 底层可能翻转分组中的位
  - 校验和检测分组错误
  - 确认机制 停-等 协议 发送等待 ACK/NAK
  - 重传机制
- rdt2.1/2.2
  rdt2.0 ACK/NAK 传送失败
  rdt2.1 重传 序列号解决重复分组
  rdt2.2 无 NAK 消息协议
- rdt3.0 错误+丢失
  发送方合理的等待时间 超过一定时间重传 解决ACK/分组丢失
  ACK/分组延迟 序列号去除重复
  性能差
#### 流水线机制与滑动窗口协议
  发送多个分组：更大的序列号范围，更大的存储空间
  窗口：允许使用的序列号范围 
  - GBN go-back-n 发送/确认