#### 垃圾回收机制

JavaScript 垃圾回收机制的原理说白了也就是定期找出那些不再用到的内存（变量），然后释放其内存

JavaScript 的引用数据类型是保存在堆内存中的，然后在栈内存中保存一个对堆内存中实际对象的引用，所以，JavaScript 中对引用数据类型的操作都是操作对象的引用而不是实际的对象。可以简单理解为，栈内存中保存了一个地址，这个地址和堆内存中的实际值是相关的

#### 标记清除算法

```js
// 垃圾收集器在运行时会给内存中的所有变量都加上一个标记，假设内存中所有对象都是垃圾，全标记为0
// 然后从各个根对象开始遍历，把不是垃圾的节点改成1
// 清理所有标记为0的垃圾，销毁并回收它们所占用的内存空间
// 最后，把所有内存中对象标记修改为0，等待下一轮垃圾回收
```

- 优点：实现比较简单
- 缺点
  - 内存碎片化
  - 分配速度慢

#### 引用计数算法

```js
// 当声明了一个变量并且将一个引用类型赋值给该变量的时候这个值的引用次数就为 1
// 如果同一个值又被赋给另一个变量，那么引用数加 1
// 如果该变量的值被其他的值覆盖了，则引用次数减 1
// 当这个值的引用次数变为 0 的时候，说明没有变量在使用，这个值没法被访问了，回收空间，垃圾回收器会在运行的时候清理掉引用次数为 0 的值占用的内存
```
