##

- 事件循环
- 虚拟 dom
- ssr
- wagmi

##

为了进行现场编程考察，你可以要求候选人实现一个 Vue 组件，这样既能测试他们对 Vue 框架的理解，也能看到他们解决问题的方法。以下是一个具体的题目示例，旨在通过实践考察候选人的能力。

### **题目：实现一个可复用的模态对话框组件**

**基本要求**:

- 使用 Vue.js 创建一个模态对话框（Modal）组件，该组件应该是可复用的。
- 模态对话框应该包括标题、内容区域和操作按钮（例如，“确认”和“取消”）。
- 通过 props 传递标题和内容。
- 发射事件来处理“确认”和“取消”操作的回调。
- 实现点击模态对话框外部区域来关闭模态对话框的功能。
- 使用简单的 CSS 来美化模态对话框的外观。

**进阶要求**:

- 提供插槽（slot）支持，允许使用者自定义内容区域和操作按钮。
- 实现动态的模态对话框大小（例如，通过 props 传递宽度和高度）。
- 实现按下 ESC 键关闭模态对话框的功能。
- 添加过渡动画效果，使模态对话框的出现和消失更加平滑。

**指导**:

- 你可以从创建一个基础的 Vue 组件开始，定义所需的 props 和事件。
- 使用**`v-if`**或**`v-show`**来控制模态对话框的显示隐藏。
- 利用 Vue 的自定义事件来处理操作按钮的逻辑。
- 使用 Vue 的插槽技术来允许内容的自定义。
- 应用简单的 CSS 样式（如使用 Flexbox 布局）来实现基本的布局和样式美化。

**评估标准**:

- **代码结构**: 组件的代码是否清晰、易于理解和维护。
- **功能完整性**: 基本和进阶要求是否得到满足。
- **代码风格**: 是否遵循 Vue 的最佳实践，包括命名约定、组件的组织方式等。
- **问题解决能力**: 在实现功能时遇到问题的解决方法和思路。

这样的题目不仅能考察候选人的 Vue 基础知识和组件开发能力，还能看到他们如何处理更复
