#### 性能优化

https://juejin.cn/post/7253828299939184697?searchId=20240104102956EC91E2E128DB225789AF

web-vitals

#### 指标

FP firstPaint 首次绘制
FCP firstContentfulPaint 首次内容绘制
LCP largestContentfulPaint 最大内容绘制
DCL domContentLoaded dom 内容解析完成
L loaded 页面的 load 事件
FCP->TBT->TTI
Lighthouse

页面加载时间：指从用户发起请求到页面完全呈现在屏幕上所经过的时间。这个指标反映了用户等待页面加载的时间，对用户体验有很大影响。

首字节时间：指从用户发起请求到浏览器接收到服务器响应的第一个字节所经过的时间。这个指标反映了服务器响应速度和网络延迟。

首屏时间：指从用户发起请求到浏览器首次渲染页面内容所经过的时间。这个指标反映了用户等待看到页面内容的时间，对用户体验有很大影响。

白屏时间：指从用户发起请求到浏览器开始渲染页面内容所经过的时间。这个指标反映了用户等待看到页面内容的时间，对用户体验有很大影响。

FCP（First Contentful Paint） ：指浏览器首次渲染来自 DOM 的任何文本、图像、非白色画布或 SVG 的时间。这个指标反映了用户等待看到页面内容的时间，对用户体验有很大影响。

LCP（Largest Contentful Paint） ：指浏览器渲染页面中最大可见元素的时间。这个指标反映了用户等待看到页面主要内容的时间，对用户体验有很大影响。

阻塞总时长（TBT）：表示页面加载过程中所有长任务阻塞主线程的总时间。它也可以通过监听页面上的长任务来计算。当一个长任务的执行时间超过 50 毫秒时，我们认为它阻塞了主线程。

可交互时间（TTI）：指从用户发起请求到页面可以正常响应用户操作所经过的时间。这个指标反映了用户等待页面可交互的时间，对用户体验有很大影响。

```js
从 FCP 指标后开始计算
持续 5 秒内无长任务（执行时间超过 50 ms）且无两个以上正在进行中的 GET 请求
往前回溯至 5 秒前的最后一个长任务结束的时间
```

作者：胡萝卜会飞
链接：https://juejin.cn/post/7219669812158414903

## 手段

#### 时序规划

前置
SSR：将模板渲染前置到服务端处理
prefetch,prerender,preload
容器预初始化
管道：无需等所有数据加载完才处理，而是加载一部分就处理一部分（html 的渲染就是这样的）

#### 运行时

- 浏览器渲染层面
  控制 DOM 和 CSS 的层级深度
  合并多个 DOM 操作
  少用 js 动画，如必要，使用专门的动画 api：requestAnimationFrame
  使用 requestIdleCallback 执行 js 任务
  硬件加速（hardware-acceleration）
  减少重排

- 体量规划
  按需绘制，只渲染需要的元素
  函数节流，降低 js 执行频率
  优雅降级，例如针对低端设备，动效元素少用阴影和渐变色（纯色、扁平化）
  时序规划
  提前渲染好组件，再执行动画

重排由 CPU 处理，重绘由 GPU 处理，CPU 的处理效率远不及 GPU，重排一定会引发重绘，重绘不一定会引发重排

作者：白胜
链接：https://juejin.cn/post/6854573208671092743
