### 期货交易

双方约定两个月后交货，交货价按交割日价格结算，这就是双方签订的一份远期合约。

#### 开仓价格

只不过在期货交易所买卖的时候，买家以$80 买入一手，并不需要支付$80,000，
而是按比例支付一个保证金，比如 10%，即买入一手原油只需要$8,000，交割的时候再按交割价补足余额。对卖家来说，
以$80 的价格卖出一手也需要支付保证金$8,000，
保证金就是交易所为防止双方违约强制冻结的金额。
$80 即买卖双方成交的价格，也是开仓价格。

#### 保证金

- 买方持有多头仓位，
- 卖方持有空头仓位，
  仓位的数量是 1，仓位价值就是$80,000，按照成交价的 10%缴纳保证金，则该仓位需要冻结保证金$8,000。注意仓位的保证金是冻结而不是支付给交易所的，交易所收取的手续费另算（通常在万 0.1 ～万 5）。

#### 价格变化 浮盈浮亏

卖方盈亏 = (开仓价 - 最新价) x 仓位数量 x 合约乘数 = (80 - 88) x 1 x 1000 = -8000
买方盈亏 = (最新价 - 开仓价) x 仓位数量 x 合约乘数 = (88 - 80) x 1 x 1000 = 8000

#### 开仓方式

- 买入开多：没有持仓时，买入后持有多仓；
- 卖出开空：没有持仓时，卖出后持有空仓；
- 卖出平多：持有多仓时，卖出后平掉多仓；
- 买入平空：持有空仓时，买入后平掉空仓。

#### 杠杆

假设小明的本金是$32,000，但他在$80 的价格只开了 1 手多仓，那么小明在价格上涨 10%的时候，实际盈利$8,000，相对于本金来说盈利 8000/32000=25%，即小明的实际杠杆率是 2.5 倍，价格上涨 10%会让小明的盈利放大 2.5 倍，而价格下跌 40%会让小明的本金亏光。

#### 空仓/多仓

只有当小明的本金为$80,000 时，要亏光全部本金，价格需要跌至 0，因此，小明如果本金为$80,000，他在$80 的价格持有 1 手多仓时，实际杠杆率为 1，即 1 倍杠杆。1 倍杠杆开多时，理论上没有爆仓风险，因为价格跌至 0 也仅仅亏掉全部本金。但是 1 倍杠杆开空是有爆仓风险的，因为价格上涨没有上限，上涨 100%就会导致 1 倍杠杆的空仓爆仓，上涨 200%就会导致 0.5 倍杠杆的空仓爆仓。可见，做空的风险比做多要大。

- 投机者的持仓量和交易额可以远超真实贸易额，理论上可无限容纳多空双方的资金，这也是为什么期货被称为一种衍生品的原因。

- 要特别注意那些现货被高度控盘的期货，因为庄家可以在期货市场先开多，再拉盘，等现货高位时，在期货市场平多后再反手开空，再在现货市场砸盘，从而达到双倍收割的效果。

#### 杠杆

假设本金 10 万，10 倍杠杆亏 5%，总亏损高达 50%，就只剩 5 万本金了。
如果想要回本，需要盈利 100%，这意味着 10 倍杠杆要盈利 10%，中间还不能有大波动。

举例：小明只有 10 万本金，他通过小额贷款借款 40 万，相当于场外 5 倍杠杆。小明以 50 万资金在场内开 10 倍杠杆，实际杠杆率高达 5 x 10 = 50，因此价格向不利方向波动 2%小明即损失 10 万自有本金，波动 10%小明爆仓并负债 40 万。除了下海干活小明已别无他法。

#### 金融期货
